package com.ematou.wxbase.service.impl;

import com.ematou.wxbase.common.web.R;
import com.ematou.wxbase.entity.MerchApp;
import com.ematou.wxbase.entity.MerchInfo;
import com.ematou.wxbase.exception.Assert;
import com.ematou.wxbase.mapper.MerchAppMapper;
import com.ematou.wxbase.mapper.MerchInfoMapper;
import com.ematou.wxbase.service.EidService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * E证通业务实现类
 *
 * @author frankeleyn
 * @email lvjian@qhdswl.com
 * @date 2023/2/18 16:56
 */
@Service
public class EidServiceImpl implements EidService {

    @Resource
    private MerchInfoMapper merchInfoMapper;

    @Resource
    private MerchAppMapper merchAppMapper;

    /**
     * 获取E证通 Token
     *
     * @return
     */
    @Override
    public R<String> getEidToken() {
        // 商户号
        String merchSn = "mhbs990053989883052032";
        // 应用编码
        String appCode = "Kmall-cw";
        // 用户姓名
        String username = "张三";
        // 待校验的用户身份证
        String idCard = "430411196705226476";
        // 校验商户
        validateMerch(merchSn);
        // 校验商户应用
        validateMerchApp(merchSn, appCode);


        return R.success(null);
    }

    private void validateMerchApp(String merchSn, String appCode) {
        MerchApp query = new MerchApp();
        query.setMerchSn(merchSn);
        query.setAppCode(appCode);
        List<MerchApp> merchApps = merchAppMapper.selectByCondition(query);
        Assert.notTrue(merchApps.size() < 1, "商户应用不存在!");
    }

    private void validateMerch(String merchSn) {
        MerchInfo query = new MerchInfo();
        query.setMerchSn(merchSn);
        MerchInfo merchInfo = merchInfoMapper.selectOne(query);
        Assert.notNull(merchInfo, "商户信息不存在!");
    }

    /**
     * 获取E证通结果
     */
    @Override
    public R<?> getEidResult() {
        return null;
    }
}
